/**
 * <p>Title: Command Bar</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2011</p>
 *
 * <p>Company: RS</p>
 *
 * @author not attributable
 * @version 1.1.0
 */

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Transparency;
import java.awt.Toolkit;

import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.PixelGrabber;

import java.net.URL;

import java.text.DateFormat;

import java.util.Date;
import java.util.MissingResourceException;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.StringTokenizer;
import java.util.Vector;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;
import javax.swing.BorderFactory;
import javax.swing.border.Border;
import javax.swing.WindowConstants;

import ij.IJ;
import ij.ImageJ;
import ij.ImagePlus;
import ij.Prefs;
import ij.WindowManager;
import ij.gui.GUI;
import ij.plugin.PlugIn;
import ij.plugin.frame.Recorder;

public class Command_Bar extends JPanel implements PlugIn, ActionListener, MouseListener, MouseMotionListener, Runnable{

    protected ImagePlus imp;
    protected ImageJ ij;
    private int offset=60, offsetHeight;
    public JButton infoButton, draggedButton, closeButton, undecoratedButton, action;
    protected JButton newButton, openButton, undoButton, copyButton, cutButton, pasteButton
            , clearButton, fillButton, drawButton, roicolorButton, colorpickerButton
            , selectButton, nonselectButton
            , splineButton, duplicateButton, captureButton, specifyButton, rotateButton, scaleButton;
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.lightGray, Color.lightGray);
    private long mouseDownTime;
    private static int current;
    public static final int DOUBLE_CLICK_THRESHOLD = 150;
    public JPanel commandBarPanel=new JPanel();
    public JLabel spaceLabel, clockLabel, label;
    public JPanel panel=new JPanel();
    protected Date date = new Date();

    private boolean running=false;
    private Thread timer;
    private String time;
    private DateFormat timeFormat;
    private static boolean isparent = false;
    private static ResourceBundle resources;
    private static String fileType = ".gif";
    private static String dir;
    static final String LOC_KEY = "stbf.loc";
    private int index = 0;
    private static int ARRAYLENGTH = 20;
    private static int PARTSLENGTH = 3;

    /*static {
        try {
            resources = ResourceBundle.getBundle("ij2x.plugin.resources.ControlBarPanel",
                                                 Locale.getDefault());
        } catch (MissingResourceException mre) {
            //System.err.println("resources/ControlBarPanel.properties not found");
            //System.exit(1);
        }
    }*/


    public Command_Bar() {
        ij = IJ.getInstance();
}

    public void run(String arg){

        ij = IJ.getInstance();
        commandBarPanel=createCommandBar();
        Dimension ijsize = ij.getSize();
        Dimension cbpsize = commandBarPanel.getPreferredSize();
        Dimension cbp2ijSize = new Dimension((int)ijsize.getWidth()-6, (int)cbpsize.getHeight());

        timeFormat= DateFormat.getTimeInstance(DateFormat.DEFAULT);
        final JFrame stframe = new JFrame("Command Bar");
        Container container = stframe.getContentPane();
        container.setMinimumSize(cbp2ijSize);      
        container.setPreferredSize(cbp2ijSize);
        container.setMaximumSize(cbp2ijSize);      
        stframe.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        stframe.addWindowListener(new WindowListener(){            
                public void windowClosing(WindowEvent e) {
                    if (e.getSource()==stframe) {
                        stframe.dispose();
                        //stframe.setVisible(false);
		Prefs.saveLocation(LOC_KEY, stframe.getLocation());
		//IJ.notifyEventListeners(IJEventListener.COLOR_PICKER_CLOSED);
                        WindowManager.removeWindow(stframe);
                    }
                }
            
                public void windowActivated(WindowEvent e) {
                            if (IJ.isMacintosh() && IJ.getInstance()!=null) {
                                    IJ.wait(10); // may be needed for Java 1.4 on OS X
                            }
                            WindowManager.setWindow(stframe);
                    }
            
                public void windowOpened(WindowEvent e) {}
                public void windowClosed(WindowEvent e) {}
                public void windowIconified(WindowEvent e) {}
                public void windowDeiconified(WindowEvent e) {}
                public void windowDeactivated(WindowEvent e) {}
            
        });
        if (ij!=null) {
                Image img = ij.getIconImage();
                if (img!=null)
                        try {stframe.setIconImage(img);} catch (Exception e) {}
        }
              container .add(commandBarPanel);
              stframe.setResizable(false);
              stframe.pack();
		Point loc = Prefs.getLocation(LOC_KEY);
		if (loc!=null)
			stframe.setLocation(loc);
		else
			//GUI.center(stframe);
                                      stframe.setLocation(new Point(ij.getLocation().x,  (int)ijsize.getHeight()));
              stframe.setVisible(true);
              start();
        
   }


    public JPanel createCommandBar(){

        java.awt.FlowLayout flayout = new java.awt.FlowLayout(java.awt.FlowLayout.LEFT);
        flayout.setHgap(0);
        flayout.setVgap(0);
        panel.setLayout(flayout);
        panel.setBorder(lightGrayBorder);
        clockLabel=createLabel(clockLabel, "", "00:00:00");
        this.setDate(new Date());
        clockLabel.setBorder(lightGrayBorder);
        dir = Prefs.getString("icondir");


        infoButton=createButton(infoButton, "Show Info ...");
        infoButton.setIcon(createIcon("s_info"));
        infoButton.setRolloverIcon(createIcon("s_info_ro"));
        infoButton.setPressedIcon(createIcon("s_info_press"));

        newButton=createButton(newButton, "New Image");
        newButton.setIcon(createIcon("s_new"));
        newButton.setRolloverIcon(createIcon("s_new_ro"));
        newButton.setPressedIcon(createIcon("s_new_press"));

        openButton=createButton(openButton, "Open Image");
        openButton.setIcon(createIcon("s_open"));
        openButton.setRolloverIcon(createIcon("s_open_ro"));
        openButton.setPressedIcon(createIcon("s_open_press"));

        duplicateButton=createButton(duplicateButton, "Duplicate Image");
        duplicateButton.setIcon(createIcon("s_duplicate"));
        duplicateButton.setRolloverIcon(createIcon("s_duplicate_ro"));
        duplicateButton.setPressedIcon(createIcon("s_duplicate_press"));

        undoButton=createButton(undoButton, "Undo Action");
        undoButton.setIcon(createIcon("s_undo"));
        undoButton.setRolloverIcon(createIcon("s_undo_ro"));
        undoButton.setPressedIcon(createIcon("s_undo_press"));

        copyButton=createButton(copyButton, "Copy Shape");
        copyButton.setIcon(createIcon("s_copy"));
        copyButton.setRolloverIcon(createIcon("s_copy_ro"));
        copyButton.setPressedIcon(createIcon("s_copy_press"));

        cutButton=createButton(cutButton, "Cut Shape");
        cutButton.setIcon(createIcon("s_cut"));
        cutButton.setRolloverIcon(createIcon("s_cut_ro"));
        cutButton.setPressedIcon(createIcon("s_cut_press"));

        pasteButton=createButton(pasteButton, "Paste Shape");
        pasteButton.setIcon(createIcon("s_paste"));
        pasteButton.setRolloverIcon(createIcon("s_paste_ro"));
        pasteButton.setPressedIcon(createIcon("s_paste_press"));

        clearButton=createButton(clearButton, "Clear Shape");
        clearButton.setIcon(createIcon("s_clear"));
        clearButton.setRolloverIcon(createIcon("s_clear_ro"));
        clearButton.setPressedIcon(createIcon("s_clear_press"));

        fillButton=createButton(fillButton, "Fill Shape");
        fillButton.setIcon(createIcon("s_fill"));
        fillButton.setRolloverIcon(createIcon("s_fill_ro"));
        fillButton.setPressedIcon(createIcon("s_fill_press"));

        drawButton=createButton(drawButton, "Draw Shape");
        drawButton.setIcon(createIcon("s_pencil"));
        drawButton.setRolloverIcon(createIcon("s_pencil_ro"));
        drawButton.setPressedIcon(createIcon("s_pencil_press"));

        selectButton=createButton(selectButton, "Select Image");
        selectButton.setIcon(createIcon("s_select"));
        selectButton.setRolloverIcon(createIcon("s_select_ro"));
        selectButton.setPressedIcon(createIcon("s_select_press"));

        nonselectButton=createButton(nonselectButton, "Non Select Image");
        nonselectButton.setIcon(createIcon("s_nonselect"));
        nonselectButton.setRolloverIcon(createIcon("s_nonselect_ro"));
        nonselectButton.setPressedIcon(createIcon("s_nonselect_press"));

        splineButton=createButton(splineButton, "Fit Spline");
        splineButton.setIcon(createIcon("s_spline"));
        splineButton.setRolloverIcon(createIcon("s_spline_ro"));
        splineButton.setPressedIcon(createIcon("s_spline_press"));

        roicolorButton=createButton(roicolorButton, "Shape Color");
        roicolorButton.setIcon(createIcon("s_shapecolor"));
        roicolorButton.setRolloverIcon(createIcon("s_shapecolor_ro"));
        roicolorButton.setPressedIcon(createIcon("s_shapecolor_press"));

        colorpickerButton=createButton(colorpickerButton, "JColor Picker");
        colorpickerButton.setIcon(createIcon("s_picker"));
        colorpickerButton.setRolloverIcon(createIcon("s_picker_ro"));
        colorpickerButton.setPressedIcon(createIcon("s_picker_press"));

        captureButton=createButton(captureButton, "Capture Screen");
        captureButton.setIcon(createIcon("s_captscreen"));
        captureButton.setRolloverIcon(createIcon("s_captscreen_ro"));
        captureButton.setPressedIcon(createIcon("s_captscreen_press"));

        specifyButton=createButton(specifyButton, "Spezify Roi");
        specifyButton.setIcon(createIcon("s_spezifyroi"));
        specifyButton.setRolloverIcon(createIcon("s_spezifyroi_ro"));
        specifyButton.setPressedIcon(createIcon("s_spezifyroi_press"));

        rotateButton=createButton(rotateButton, "Spezify Roi");
        rotateButton.setIcon(createIcon("s_rotate"));
        rotateButton.setRolloverIcon(createIcon("s_rotate_ro"));
        rotateButton.setPressedIcon(createIcon("s_rotate_press"));

        scaleButton=createButton(scaleButton, "Spezify Roi");
        scaleButton.setIcon(createIcon("s_scale"));
        scaleButton.setRolloverIcon(createIcon("s_scale_ro"));
        scaleButton.setPressedIcon(createIcon("s_scale_press"));

        spaceLabel = new JLabel();
        offsetHeight=(int)infoButton.getPreferredSize().getHeight();
        spaceLabel.setMinimumSize(new Dimension(offset, offsetHeight));
        spaceLabel.setMaximumSize(new Dimension(offset, offsetHeight));
        spaceLabel.setPreferredSize(new Dimension(offset, offsetHeight));
        panel.add(newButton);
        panel.add(openButton);
        panel.add(undoButton);
        panel.add(copyButton);
        panel.add(cutButton);
        panel.add(pasteButton);
        panel.add(clearButton);
        panel.add(fillButton);
        panel.add(drawButton);
        //panel.add(roicolorButton);
        panel.add(colorpickerButton);
        panel.add(specifyButton);
        panel.add(selectButton);
        panel.add(nonselectButton);
        panel.add(splineButton);
        panel.add(duplicateButton);
        panel.add(captureButton);
        panel.add(rotateButton);
        panel.add(scaleButton);
        panel.add(infoButton);

        JPanel stbPanel = new JPanel();
        stbPanel.setLayout(new BorderLayout());
        stbPanel.add(BorderLayout.WEST, panel);
        stbPanel.add(BorderLayout.CENTER, spaceLabel);
        stbPanel.add(BorderLayout.EAST, clockLabel);
        return stbPanel;
     }
     private JLabel createLabel(JLabel label, String tooltip, String text){
         label = new JLabel(text);
         label.setToolTipText(tooltip);
         label.addMouseListener(new MouseListener(){
         public void mousePressed(MouseEvent e){
             labelEvent(e);
         }
         public void mouseReleased(MouseEvent e) {}
         public void mouseExited(MouseEvent e) {}
         public void mouseClicked(MouseEvent e) {}
         public void mouseEntered(MouseEvent e) {}
         });
     return label;
     }

     public void labelEvent(MouseEvent e){
         /*JLabel label = (JLabel)e.getSource();
         JFrame[] editFrame = WindowManager.getNonImageWindows();
         for(int i=0; i < editFrame.length; i++){
             //IJ.log("" + editFrame[i].getClass().getName());
             if (editFrame[i].getClass().getName().equals("com.ibm.JCalendar")){
                 isparent=true;
                 editFrame[i].setVisible(false);
                 WindowManager.removeWindow(editFrame[i]);
             }else isparent=false;
        }
        if(label==clockLabel && !isparent){
           IJ.runPlugIn("com.ibm.JCalendar", "");
       }*/
     }
     private JButton createButton(JButton action, String tooltip, Image[] image){
         action = new JButton();
           action.setToolTipText(tooltip);
             action.addActionListener(this);
               action.addMouseListener(this);
             action.addMouseMotionListener(this);
            setBorderlessButton(action);
         setIcon(action, image);
     return action;
     }

     private JButton createButton(JButton action, String tooltip){
         action = new JButton();
            action.setToolTipText(tooltip);
             action.addActionListener(this);
           action.addMouseListener(this);
          action.addMouseMotionListener(this);
         setBorderlessButton(action);
     return action;
     }

     private Icon createIcon(String key){
         Icon icon = null;
         String fileName=key + getFileType();
         if(getImageDir() == null){
            dir="images/commandbar/";
         }
         String path = getImageDir()+fileName;
        try {
            URL url = this.getClass().getResource(path);
            Image image = Toolkit.getDefaultToolkit().createImage(url);
            if (url != null) {
                icon = new ImageIcon(image);
            }
        } catch (Exception ex) {
        }
     return icon;
     }
     private String getFileType(){
           return fileType;
     }
     private String getImageDir(){
           return dir;
     }
     private void setIcon(JButton action, Image[] image){
         action.setIcon(new ImageIcon(image[0]));
           action.setRolloverIcon(new ImageIcon(image[1]));
         action.setPressedIcon(new ImageIcon(image[2]));
     }


     void setButtonDim(JButton action, Dimension maxDim, Dimension preDim, Dimension minDim){
       action.setMaximumSize(maxDim);
          action.setPreferredSize(preDim);
       action.setMinimumSize(minDim);
   }

     void setBorderlessButton(JButton button){
           button.setMargin(new Insets(0, 0, 0, 0));
              button.setBorderPainted(false);
              button.setContentAreaFilled(false);
           button.setFocusPainted(false);
       }

       public void mousePressed(MouseEvent e) {
           action = (JButton)e.getSource();
           int x = e.getX();
           boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
           mouseDownTime = System.currentTimeMillis();
                if (!doubleClick) {
                }
        }

        public void mouseReleased(MouseEvent e) {}
        public void mouseExited(MouseEvent e) {}
        public void mouseClicked(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}

        public void mouseDragged(MouseEvent e) {}
        public void mouseMoved(MouseEvent e) {
            JButton action = (JButton)e.getSource();
            int x = e.getX();
            boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
            mouseDownTime = System.currentTimeMillis();
                 if (!false) {
                     if(action == infoButton){
                         IJ.showStatus("Command: Show Info...");
                     }
                     else if(action == openButton){
                         IJ.showStatus("Command: Open...");
                     }
                     else if(action == newButton){
                         IJ.showStatus("Command: Image...");
                     }
                     else if(action == undoButton){
                         IJ.showStatus("Command: Undo");
                     }
                     else if(action == copyButton){
                         IJ.showStatus("Command: Copy");
                     }
                     else if(action == cutButton){
                         IJ.showStatus("Command: Cut");
                     }
                     else if(action == pasteButton){
                         IJ.showStatus("Command: Paste");
                     }
                     else if(action == clearButton){
                         IJ.showStatus("Command: Clear");
                     }
                     else if(action == fillButton){
                         IJ.showStatus("Command: Fill");
                     }
                     else if(action == drawButton){
                         IJ.showStatus("Command: Draw");
                     }
                     else if(action == duplicateButton){
                         IJ.showStatus("Command: Duplicate...");
                     }
                     else if(action == scaleButton){
                         IJ.showStatus("Command: Scale...");
                     }
                     else if(action == selectButton){
                         IJ.showStatus("Command: Select All");
                     }
                     else if(action == nonselectButton){
                         IJ.showStatus("Select None");
                     }
                     else if(action == rotateButton){
                         IJ.showStatus("Command: Arbitrarily...");
                     }
                     else if(action == splineButton){
                         IJ.showStatus("Command: Fit Spline");
                     }
                     else if(action == roicolorButton){
                             IJ.showStatus("Command: Roi Color");
                     }
                     else if(action == colorpickerButton){
                         IJ.showStatus("Command: JColor Picker...");
                     }
                     else if(action == captureButton){
                         IJ.showStatus("Command: Capture Screen ");
                     }
                     else if (action == draggedButton) {
                         IJ.showStatus("Move...");
                     }
                     else if (action == closeButton) {
                         IJ.showStatus("Decorated Frame");
                     }
                     else if (action == undecoratedButton) {
                         IJ.showStatus("Undecorated Frame");
                     }

                 }
        }
        // Action listener method
        public void actionPerformed(ActionEvent e){
            try {
                if(action == infoButton){
                    IJ.doCommand("Show Info...");
                }
                else if(action == openButton){
                    IJ.doCommand("Open...");
                }
                else if(action == newButton){
                    IJ.doCommand("Image...");
                    //IJ.run("Image...", "");
                }
                else if(action == undoButton){
                    IJ.doCommand("Undo");
                }
                else if(action == copyButton){
                    IJ.doCommand("Copy");
                }
                else if(action == cutButton){
                    IJ.doCommand("Cut");
                }
                else if(action == pasteButton){
                    IJ.doCommand("Paste");
                }
                else if(action == clearButton){
                    IJ.doCommand("Clear");
                }
                else if(action == fillButton){
                    IJ.doCommand("Fill");
                }
                else if(action == drawButton){
                    IJ.doCommand("Draw");
                }
                else if(action == duplicateButton){
                    IJ.doCommand("Duplicate...");
                }
                else if(action == selectButton){
                    IJ.doCommand("Select All");
                }
                else if(action == nonselectButton){
                    IJ.doCommand("Select None");
                }
                else if(action == splineButton){
                    IJ.doCommand("Fit Spline");
                }
                else if(action == colorpickerButton){
                        //IJ.runPlugIn("ij2x.plugin.frame.JColorPicker","");
                        IJ.runPlugIn("ij.plugin.frame.ColorPicker","");
                }
                else if(action == roicolorButton){
                        IJ.runPlugIn("ij2x.plugin.ThreeColor","");
                }
                else if(action == captureButton){
                    IJ.doCommand("Capture Screen");
                }
                else if(action == scaleButton){
                         IJ.doCommand("Scale...");
                }
                else if(action == rotateButton){
                         IJ.runPlugIn("ij.plugin.filter.Rotator", "");
                }
                else if(action == specifyButton){
                    IJ.doCommand("Specify...");
                }
            } catch (Exception ex) {

            }
        }
        public void setDate(Date date) {
            this.date = date;
        }

        /* geter methods for the timeFormat value*/
        public String getTimeFormatToString() {
            return time;
        }

        /* seter methods for the timeFormat value*/
        public void setTimeFormatToString(String time) {
            this.time = time;
        }

        /* interface Runnable methods */
        public void start() {
            running = true;
            if (timer == null)
                timer = new Thread(this);
            timer.start();
        }

        public void stop() {
            timer = null;
            notify();
        }

        public void run() {
            while (running) {
                String tFormat = timeFormat.format(new Date());
                setTimeFormatToString(tFormat);
                this.setDate(new Date());
                try {
                    Thread.sleep(100);
                    if(clockLabel != null){
                        clockLabel.setText(tFormat);
                        clockLabel.setToolTipText("Die Zeit:" + tFormat);
                    }
                 } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            timer = null;
        }

}
