package ij.plugin.frame;

import ij.IJ;
import ij.ImageJ;
import ij.WindowManager;
import ij.plugin.PlugIn;
import java.awt.AWTEvent;
import java.awt.Image;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JFrame;
import javax.swing.WindowConstants;
import java.awt.Container;

/**  This is a closeable window that plugins can extend. */
public class PlugInFrame extends JFrame implements PlugIn, WindowListener, FocusListener {

    String title;
    public Container container;

        public PlugInFrame(String title) {
                super(title);
                enableEvents(AWTEvent.WINDOW_EVENT_MASK);
                this.title = title;
                this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
                ImageJ ij = IJ.getInstance();
                addWindowListener(this);
                addFocusListener(this);

                if (ij!=null) {
                        Image img = ij.getIconImage();
                        if (img!=null)
                                try {setIconImage(img);} catch (Exception e) {}
                }
                container=PlugInFrame.this.getContentPane();
                this.setResizable(false);
        }

        public void run(String arg) {
        }

    public void windowClosing(WindowEvent e) {
        if (e.getSource()==this) {
                close();
                if (Recorder.record)
                        Recorder.record("run", "Close");
        }
    }

    public void windowActivated(WindowEvent e) {
                if (IJ.isMacintosh() && IJ.getInstance()!=null) {
                        IJ.wait(10); // may be needed for Java 1.4 on OS X
                        //setJMenuBar(Menus.getMenuBar());
                }
                WindowManager.setWindow(this);
        }

    public void windowOpened(WindowEvent e) {}
    public void windowClosed(WindowEvent e) {}
    public void windowIconified(WindowEvent e) {}
    public void windowDeiconified(WindowEvent e) {}
    public void windowDeactivated(WindowEvent e) {}

    /** Closes this window. */
    public void close() {
                //setVisible(false);
                dispose();
                WindowManager.removeWindow(this);
    }

        public void focusLost(FocusEvent e) {}
        public void focusGained(FocusEvent e) {
                //IJ.log("PlugInFrame: focusGained");
                WindowManager.setWindow(this);
        }

}
